/* ***************************************************************
3DBUTTON Test Application

Copyright (C) 1991 Mark S. Douglas
All Rights Reserved.
*************************************************************** */


#include <windows.h>
#include <3dbutton.h>


#define CID_BITMAP  100
#define CID_ICON    101

#define CX_BITMAP   48
#define CY_BITMAP   48
#define CX_ICON     48
#define CY_ICON     48


LONG FAR PASCAL _export WndAppProc(HWND hwnd,WORD wMsg,WORD wParam,LONG lParam);


static HANDLE   hAppInst;
static HBITMAP  hbmBitmap;
static HWND     hwndBitmap;
static int      xBitmap;
static int      yBitmapText;
static int      xIcon;
static int      yIconText;
static HWND     hwndIcon;
static int      cyWindow;

static char     szButton[]    = "BUTTON";
static char     szClassName[] = "3DTest";
static char     szCopyright[] = "3DBUTTON Test Application\nCopyright  1991 Mark S. Douglas\nAll Rights Reserved.";


int PASCAL      WinMain(HANDLE hInst,HANDLE hPrevInst,LPSTR lpszCmdLine,int nCmdShow)
{
    HWND        hwnd;
    MSG         msg;
    WNDCLASS    wndcls;

    hAppInst = hInst;

    if(!hPrevInst) {
    	wndcls.style		 = CS_HREDRAW|CS_VREDRAW;
	    wndcls.lpfnWndProc   = WndAppProc;
       	wndcls.cbClsExtra    = 0;
       	wndcls.cbWndExtra	 = 0;
        wndcls.hInstance     = hInst;
	    wndcls.hIcon	 	 = NULL;
       	wndcls.hCursor	     = LoadCursor(NULL,IDC_ARROW);
       	wndcls.hbrBackground = COLOR_BTNFACE + 1;
       	wndcls.lpszMenuName  = NULL;
       	wndcls.lpszClassName = szClassName;

        if(!RegisterClass(&wndcls)) return FALSE;
    }

    hwnd       = CreateWindow(szClassName,szClassName,WS_OVERLAPPEDWINDOW,CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,NULL,NULL,hInst,NULL);
    hwndBitmap = CreateWindow(szButton,NULL,BS_OWNERDRAW|WS_CHILD|WS_VISIBLE,NULL,NULL,CX_BITMAP,CY_BITMAP,hwnd,CID_BITMAP,hInst,NULL);
    hwndIcon   = CreateWindow(szButton,"ICON",BS_OWNERDRAW|WS_CHILD|WS_VISIBLE,NULL,NULL,CX_ICON,CY_ICON,hwnd,CID_ICON,hInst,NULL);

    ShowWindow(hwnd,nCmdShow);

    while(GetMessage(&msg,NULL,0,0)) {
        TranslateMessage(&msg);
        DispatchMessage(&msg);
    }

    return 0;
}


LONG FAR PASCAL _export WndAppProc(HWND hwnd,WORD wMsg,WORD wParam,LONG lParam)
{
    PAINTSTRUCT paint;

    switch(wMsg) {
    case WM_CREATE:
        hbmBitmap = LoadBitmap(hAppInst,"BITMAP");
        break;
    case WM_DESTROY:
        DeleteObject(hbmBitmap);
        PostQuitMessage(0);
        break;
    case WM_DRAWITEM:
        if(((LPDRAWITEMSTRUCT)lParam)->CtlID == CID_BITMAP) WndDrawBitmapButton((LPDRAWITEMSTRUCT)lParam,hbmBitmap);
        else WndDrawIconButton((LPDRAWITEMSTRUCT)lParam,NULL);
        break;
    case WM_PAINT:
        BeginPaint(hwnd,&paint);

        SetBkColor(paint.hdc,RGB(192,192,192)); // Light Gray

        lParam = SetTextColor(paint.hdc,RGB(0,0,255));
        paint.rcPaint.left   = 3;
        paint.rcPaint.top    = 0;
        paint.rcPaint.bottom = cyWindow - 1;
        DrawText(paint.hdc,szCopyright,sizeof(szCopyright) - 1,&paint.rcPaint,DT_LEFT|DT_NOCLIP|DT_TOP);
        SetTextColor(paint.hdc,lParam);

        paint.rcPaint.left  = xBitmap;
        paint.rcPaint.top   = yBitmapText;
        paint.rcPaint.right = paint.rcPaint.left + CX_BITMAP;
        DrawText(paint.hdc,"Bitmap",6,&paint.rcPaint,DT_CENTER|DT_NOCLIP|DT_TOP);

        paint.rcPaint.left  = xIcon;
        paint.rcPaint.top   = yIconText;
        paint.rcPaint.right = paint.rcPaint.left + CX_ICON;
        DrawText(paint.hdc,"Icon",4,&paint.rcPaint,DT_CENTER|DT_NOCLIP|DT_TOP);

        EndPaint(hwnd,&paint);
        break;
    case WM_SIZE:
        cyWindow    = HIWORD(lParam);
        xBitmap     = (LOWORD(lParam) - CX_BITMAP) / 2 - CX_BITMAP;
        yBitmapText = (cyWindow - CY_BITMAP) / 2;
        xIcon       = (LOWORD(lParam) - CX_ICON) / 2 + CX_ICON;
        yIconText   = (cyWindow - CY_ICON) / 2;

        SetWindowPos(hwndBitmap,NULL,xBitmap,yBitmapText,NULL,NULL,SWP_NOACTIVATE|SWP_NOSIZE|SWP_NOZORDER);
        SetWindowPos(hwndIcon,NULL,xIcon,yIconText,NULL,NULL,SWP_NOACTIVATE|SWP_NOSIZE|SWP_NOZORDER);

        yBitmapText += CY_BITMAP + 4;
        yIconText   += CY_ICON + 4;
        break;
    default:
        return DefWindowProc(hwnd,wMsg,wParam,lParam);
    }

    return NULL;
}
