/*
	ERROR0.H -- short version of the include file to import
	API from ERROR.DLL
	Copyright (C) Eugene Sokolov 1992-93, (516)632-7892,
	esokolov@sbchm1.chem.sunysb.edu

	You can freely copy, change or redistribute this file as long
	as this notice remains intact.
*/

#ifndef __ERROR0_H
#define __ERROR0_H

#ifndef __WINDOWS_H
#define STRICT
#include <windows.h>
#endif /* __WINDOWS_H */

#define ErrorHandler 	ERRORHANDLER	//Change to uppercase, DLL exports
					//ErrorHandler as an uppercase.

/* exported functions */
/*
   CreateStatusWindow( 	DWORD dwStyle, int x0, int y0, int dx, int dy, 
			HWND hwndParent, HINSTANCE hInst );
   DWORD dwStyle	-window style, passed unchanged to CreateWindow
   int x0, y0		-coordinates (hor, vert) of an upper left corner
   int dx, dy		-width and height of the status bar window.
   HWND hwndParent	-handle of the parent window.
   HINSTANCE hInst	-handle of the instance this window belongs to.
			(NOT a DLL instance!!!)
	
	Returns:
	Handle of the status bar window on success, NULL otherwise.
*/
HWND WINAPI		CreateStatusWindow	( DWORD, int, int, int, int, HWND, HINSTANCE );

/*
   ErrorHandler( HWND hwndSB, LPSTR lpszFormat, ... );

   HWND hwndSB		-handle of Status Bar window;
   LPSTR lpszFormat	-format string followed by arguments
   			(same as wsprintf());
*/
VOID FAR CDECL		ErrorHandler		( HWND, LPSTR, ... );

/*
   DLL also exports several other functions. You will get a full version of
   this header file with explanations and definitions if you register.
*/
  
#endif /* __ERROR_H */