// File from page 642 in "Thinking in C++" by Bruce Eckel
//////////////////////////////////////////////////
// From the compressed package ECKELT01.ZIP 2/21/95
// Copyright (c) Bruce Eckel, 1995 
// Source code file from the book "Thinking in C++", 
// Prentice Hall, 1995, ISBN: 0-13-917709-4
// All rights reserved EXCEPT as allowed by the following 
// statements: You may freely use this file for your own 
// work, including modifications and distribution in 
// executable form only. You may copy and distribute this 
// file, as long as it is only distributed in the complete 
// (compressed) package with the other files from this 
// book and you do not remove this copyright and notice. 
// You may not distribute modified versions of the source 
// code in this package. This package may be freely placed 
// on bulletin boards, internet nodes, shareware disks and 
// product vendor disks. You may not use this file in 
// printed media without the express permission of the 
// author. Bruce Eckel makes no 
// representation about the suitability of this software 
// for any purpose. It is provided "as is" without express 
// or implied warranty of any kind. The entire risk as to 
// the quality and performance of the software is with 
// you. Should the software prove defective, you assume 
// the cost of all necessary servicing, repair, or 
// correction. 
// If you think you've found an error, please 
// email all modified files with loudly commented changes 
// to: eckel@aol.com (please use the same 
// address for non-code errors found in the book).
//////////////////////////////////////////////////

//: SPECIAL.CPP -- Template specialization
// A special sort for char*
#include <iostream.h>
#include "..\14\sorted.h"

class sorted<char> :  public tstash<char> {
  void bubblesort();
public:
  int add(char* element) {
	 tstash<char>::add(element);
	 bubblesort();
	 return 0; // Sort moves the element
  }
};

void sorted<char>::bubblesort() {
  for(int i = count(); i > 0; i--)
	 for(int j = 1; j < i; j++)
		if(strcmp(storage[j], storage[j-1]) < 0) {
		  // Swap the two elements:
		  char* t = storage[j-1];
		  storage[j-1] = storage[j];
		  storage[j] = t;
		}
}

char* words[] = {
  "is", "running", "big", "dog", "a",
};
const wsz = sizeof words/sizeof *words;

main() {
  sorted<char> sc;
  for(int k = 0; k < wsz; k++)
    sc.add(words[k]);
  for(int l = 0; l < sc.count(); l++)
    cout << sc[l] << endl;
}
