// File from page 586 in "Thinking in C++" by Bruce Eckel
//////////////////////////////////////////////////
// From the compressed package ECKELT01.ZIP 2/21/95
// Copyright (c) Bruce Eckel, 1995 
// Source code file from the book "Thinking in C++", 
// Prentice Hall, 1995, ISBN: 0-13-917709-4
// All rights reserved EXCEPT as allowed by the following 
// statements: You may freely use this file for your own 
// work, including modifications and distribution in 
// executable form only. You may copy and distribute this 
// file, as long as it is only distributed in the complete 
// (compressed) package with the other files from this 
// book and you do not remove this copyright and notice. 
// You may not distribute modified versions of the source 
// code in this package. This package may be freely placed 
// on bulletin boards, internet nodes, shareware disks and 
// product vendor disks. You may not use this file in 
// printed media without the express permission of the 
// author. Bruce Eckel makes no 
// representation about the suitability of this software 
// for any purpose. It is provided "as is" without express 
// or implied warranty of any kind. The entire risk as to 
// the quality and performance of the software is with 
// you. Should the software prove defective, you assume 
// the cost of all necessary servicing, repair, or 
// correction. 
// If you think you've found an error, please 
// email all modified files with loudly commented changes 
// to: eckel@aol.com (please use the same 
// address for non-code errors found in the book).
//////////////////////////////////////////////////

//: STACKT.H -- Simple stack template
#ifndef STACKT_H_
#define STACKT_H_

template<class T>
class stackt {
  enum { ssize = 100 };
  T stack[ssize];
  int top;
public:
  stackt() : top(0) { stack[top] = 0; }
  void push(const T& i) {
    if(top < ssize) stack[top++] = i;
  }
  T pop() {
    return stack[top > 0 ? --top : top];
  }
  friend class stacktIter<T>;
};

template<class T>
class stacktIter {
  stackt<T>& S;
  int index;
public:
  stacktIter(stackt<T>& is)
    : S(is), index(0) {}
  T& operator++() { // Prefix form
    if (index < S.top - 1) index++;
    return S.stack[index];
  }
  T& operator++(int) { // Postfix form
    int returnIndex = index;
    if (index < S.top - 1) index++;
    return S.stack[returnIndex];
  }
};
#endif // STACKT_H_
