// File from page 601 in "Thinking in C++" by Bruce Eckel
//////////////////////////////////////////////////
// From the compressed package ECKELT01.ZIP 2/21/95
// Copyright (c) Bruce Eckel, 1995 
// Source code file from the book "Thinking in C++", 
// Prentice Hall, 1995, ISBN: 0-13-917709-4
// All rights reserved EXCEPT as allowed by the following 
// statements: You may freely use this file for your own 
// work, including modifications and distribution in 
// executable form only. You may copy and distribute this 
// file, as long as it is only distributed in the complete 
// (compressed) package with the other files from this 
// book and you do not remove this copyright and notice. 
// You may not distribute modified versions of the source 
// code in this package. This package may be freely placed 
// on bulletin boards, internet nodes, shareware disks and 
// product vendor disks. You may not use this file in 
// printed media without the express permission of the 
// author. Bruce Eckel makes no 
// representation about the suitability of this software 
// for any purpose. It is provided "as is" without express 
// or implied warranty of any kind. The entire risk as to 
// the quality and performance of the software is with 
// you. Should the software prove defective, you assume 
// the cost of all necessary servicing, repair, or 
// correction. 
// If you think you've found an error, please 
// email all modified files with loudly commented changes 
// to: eckel@aol.com (please use the same 
// address for non-code errors found in the book).
//////////////////////////////////////////////////

//: TSTKTST.CPP -- Use template list & iterator
#include "..\14\tstack.h"
#include "..\11\strings.h"
#include <fstream.h>
#include "..\allege.h"

main() {
  ifstream file("tstktst.cpp");
  allegefile(file);
  const bufsize = 100;
  char buf[bufsize];
  tstack<String> textlines;
  // Read file and store lines in the list:
  while(file.getline(buf,bufsize))
    textlines.push(String::make(buf));
  int i = 0;
  // Use iterator to print lines from the list:
  tstackIterator<String> it(textlines);
  tstackIterator<String>* it2 = 0;
  while(it) {
    cout << *it.current() << endl;
    it++;
    if(++i == 10) // Remember 10th line
      it2 = new tstackIterator<String>(it);
  }
  cout << *(it2->current()) << endl;
  delete it2;
}
