// Non-printed example in "Thinking in C++" by Bruce Eckel
//////////////////////////////////////////////////
// From the compressed package ECKELT01.ZIP 2/21/95
// Copyright (c) Bruce Eckel, 1995 
// Source code file from the book "Thinking in C++", 
// Prentice Hall, 1995, ISBN: 0-13-917709-4
// All rights reserved EXCEPT as allowed by the following 
// statements: You may freely use this file for your own 
// work, including modifications and distribution in 
// executable form only. You may copy and distribute this 
// file, as long as it is only distributed in the complete 
// (compressed) package with the other files from this 
// book and you do not remove this copyright and notice. 
// You may not distribute modified versions of the source 
// code in this package. This package may be freely placed 
// on bulletin boards, internet nodes, shareware disks and 
// product vendor disks. You may not use this file in 
// printed media without the express permission of the 
// author. Bruce Eckel makes no 
// representation about the suitability of this software 
// for any purpose. It is provided "as is" without express 
// or implied warranty of any kind. The entire risk as to 
// the quality and performance of the software is with 
// you. Should the software prove defective, you assume 
// the cost of all necessary servicing, repair, or 
// correction. 
// If you think you've found an error, please 
// email all modified files with loudly commented changes 
// to: eckel@aol.com (please use the same 
// address for non-code errors found in the book).
//////////////////////////////////////////////////

//: BEFORE.CPP -- The "before()" function
#include <typeinfo.h>
#include <fstream.h>
ofstream out("before.out");

class base {
public:
  virtual void x() {} // Install VPTR/VTABLE
};

class d1 : public base {};
class d2 : public d1 {};
class d3 : public d2 {} D3;

#define B(arg) \
  if(arg) out << "true: "; \
  else out << "false: "; \
  out << #arg << endl;

main() {
  base* bp = &D3; // Upcast
  B(typeid(base).before(typeid(d1)));
  B(typeid(base).before(typeid(d2)));
  B(typeid(base).before(typeid(d3)));
  B(typeid(base).before(typeid(base)));
  out << endl;
  B(typeid(d1).before(typeid(base)));
  B(typeid(d2).before(typeid(base)));
  B(typeid(d3).before(typeid(base)));
  B(typeid(base).before(typeid(base)));
  out << endl;
  B(typeid(bp).before(typeid(d1)));
  B(typeid(bp).before(typeid(d2)));
  B(typeid(bp).before(typeid(d3)));
  B(typeid(bp).before(typeid(base)));
  out << endl;
  B(typeid(*bp).before(typeid(d1)));
  B(typeid(*bp).before(typeid(d2)));
  B(typeid(*bp).before(typeid(d3)));
  B(typeid(*bp).before(typeid(base)));
  out << endl;
  B(typeid(d1).before(typeid(bp)));
  B(typeid(d2).before(typeid(bp)));
  B(typeid(d3).before(typeid(bp)));
  B(typeid(base).before(typeid(bp)));
  out << endl;
  B(typeid(d1).before(typeid(*bp)));
  B(typeid(d2).before(typeid(*bp)));
  B(typeid(d3).before(typeid(*bp)));
  B(typeid(base).before(typeid(*bp)));
}
