// File from page 195 in "Thinking in C++" by Bruce Eckel
//////////////////////////////////////////////////
// From the compressed package ECKELT01.ZIP 2/21/95
// Copyright (c) Bruce Eckel, 1995 
// Source code file from the book "Thinking in C++", 
// Prentice Hall, 1995, ISBN: 0-13-917709-4
// All rights reserved EXCEPT as allowed by the following 
// statements: You may freely use this file for your own 
// work, including modifications and distribution in 
// executable form only. You may copy and distribute this 
// file, as long as it is only distributed in the complete 
// (compressed) package with the other files from this 
// book and you do not remove this copyright and notice. 
// You may not distribute modified versions of the source 
// code in this package. This package may be freely placed 
// on bulletin boards, internet nodes, shareware disks and 
// product vendor disks. You may not use this file in 
// printed media without the express permission of the 
// author. Bruce Eckel makes no 
// representation about the suitability of this software 
// for any purpose. It is provided "as is" without express 
// or implied warranty of any kind. The entire risk as to 
// the quality and performance of the software is with 
// you. Should the software prove defective, you assume 
// the cost of all necessary servicing, repair, or 
// correction. 
// If you think you've found an error, please 
// email all modified files with loudly commented changes 
// to: eckel@aol.com (please use the same 
// address for non-code errors found in the book).
//////////////////////////////////////////////////

//: BVTEST.CPP -- Testing the BitVector class
#include "..\4\bitvect.h"

main() {
  unsigned char b[] = {
    0x0f, 0xff, 0xf0,
    0xAA, 0x78, 0x11
  };
  BitVector bv1(b, sizeof b / sizeof *b),
    bv2("10010100111100101010001010010010101");
  bv1.print("bv1 before modification");
  for(int i = 36; i < bv1.bits(); i++)
    bv1.clear(i);
  bv1.print("bv1 after modification");
  bv2.print("bv2 before modification");
  for(i=bv2.bits()-10; i < bv2.bits(); i++)
    bv2.clear(i);
  bv2.set(30);
  bv2.print("bv2 after modification");
  bv2.bits(bv2.bits() / 2);
  bv2.print("bv2 cut in half");
  bv2.bits(bv2.bits() + 10);
  bv2.print("bv2 grown by 10");
  BitVector bv3((unsigned char*)0);
}
