/**************************************************************************
These C++ classes are copyright 1989, 1990, 1991 by William Herrera.
I hereby release this source code for free distrubution and use.
If you modify it and distribute it, please indicate any changes you
make as your own and the code as copyrighted above.
**************************************************************************/

// file error.hpp class declaration for Error reporting class.

#if !defined(ERROR_HPP)
#define ERROR_HPP

class Error
{
public:
	// constructors do all the work by calling static functions.
	Error(const int errlevel);
	Error(const char * p, const char * q = " ",
		const char * r = "\n", const int errlevel = 1);

	static void SetiStateErrorFunc(void (*f)(const int));

	static void SetpcpciStateErrorFunc(void (*f)(const char *,
		const char *, const char *, const int));

protected:
	static void iStateError(const int errlevel);
	static void pcpciStateError(const char * p, const char * q,
		const char * r, const int errlevel);
	static void (*errfunc_i)(const int);
	static void (*errfunc_pcpci)(const char *, const char *,
		const char *, const int);
};


#endif
// end of file error.hpp
