/**************************************************************************
These C++ classes are copyright 1989, 1990, 1991 by William Herrera.
I hereby release this source code for free distrubution and use.
If you modify it and distribute it, please indicate any changes you
make as your own and the code as copyrighted above.
**************************************************************************/
// File pointerh.hpp class declaration for PointerHeap class.
// This a special-purpose heap allocator which only allocates
// void pointers of the size specified by the current memory model.

#if !defined(POINTERH_HPP)
#define POINTERH_HPP


class PointerHeap
{
public:
	PointerHeap(int siz = 1000);	// constructor
	~PointerHeap();                 // destructor
	void ** Allocate();				// allocate a void pointer
	void Deallocate(void ** p);		// deallocate the pointer
private:
	void ** heap;					// pointer to memory for heap
	void ** nextAvailable;			// next ponter for Allocate
	void ** last;					// last pointer in pool
	int size;						// number of pointers in pool
};


#endif

//end of file pointerh.hpp
