#if !defined(__formatbr_h)              // Sentry, use file only if it's not already included.
#define __formatbr_h

/*  Project richctrl
	DHB Software
	Copyright  1996. All Rights Reserved.

	SUBSYSTEM:    richctrl.apx Application
	FILE:         formatbr.h
	AUTHOR:       David H. Borg


	OVERVIEW
	========
	Class definition for FormatBar (TWindow).
*/

#include <owl\owlpch.h>
#pragma hdrstop


#include <commctrl.h>			// Windows 95 Common Controls Header File
#include "tolcmbbx.h"			// Custom TComboBox for use on toolbars
#include "rchctrla.rh"            // Definition of all resources.


// Font demo constants
const int MaxNumFonts = 64; // Maximum number of fonts displayable in FontDemo


//{{TWindow = FormatBar}}
class FormatBar : public TWindow {
public:
	FormatBar (TWindow* parent, int id, int w = 0, int h = 0, TModule* module = 0);
	virtual ~FormatBar ();

protected:
	int fmtBitmap;
	TBADDBITMAP fbFormatBmp;
	ToolComboBox *fontType, *fontSize;

	void SetupFormatBar ();
	void FillComboBoxes ();

private:
	// make default constructor private.
	FormatBar (TWindow* parent, const char far* title = 0, TModule* module = 0);

//{{FormatBarVIRTUAL_BEGIN}}
public:
	virtual char far* GetClassName ();
	virtual void SetupWindow ();
	virtual bool IdleAction (long idleCount);
//{{FormatBarVIRTUAL_END}}

//{{FormatBarRSP_TBL_BEGIN}}
protected:
	void BnClicked();
	void CBNSelChangeFontFace();
	void CBNSelChangeFontSize();
	void CBNCloseUpFontFace();
	void CBNCloseUpFontSize();
	LRESULT EvCommonControlNotify( WPARAM wParam, LPARAM lParam);
	void EvPaint ();
//{{FormatBarRSP_TBL_END}}
DECLARE_RESPONSE_TABLE(FormatBar);
};    //{{FormatBar}}


#endif                                      // __formatbr_h sentry.

