#if !defined(__rchctrla_h)              // Sentry, use file only if it's not already included.
#define __rchctrla_h

/*  Project RichCtrl
    DHB Software
    Copyright  1996. All Rights Reserved.

    SUBSYSTEM:    richctrl.exe Application
    FILE:         rchctrla.h
    AUTHOR:       David H. Borg


    OVERVIEW
    ========
    Class definition for RichCtrlApp (TApplication).      
*/


#include <owl\owlpch.h>
#pragma hdrstop

#include "apxprint.h"

#include "rchctrla.rh"            // Definition of all resources.


//
// FrameWindow must be derived to override Paint for Preview and Print.
//
//{{TDecoratedFrame = SDIDecFrame}}
class SDIDecFrame : public TDecoratedFrame {
public:
    SDIDecFrame (TWindow *parent, const char far *title, TWindow *clientWnd, bool trackMenuSelection = false, TModule *module = 0);
    ~SDIDecFrame ();
};    //{{SDIDecFrame}}


//{{TApplication = RichCtrlApp}}
class RichCtrlApp : public TApplication {
private:

public:
    RichCtrlApp ();
    virtual ~RichCtrlApp ();

    // Public data members used by the print menu commands and Paint routine in MDIChild.
    TPrinter        *Printer;                           // Printer support.
    int             Printing;                           // Printing in progress.

protected:
	// handle to the RICHEDIT control library
	TModule *rtfModule;

	// pointer to rich edit control window
	TWindow *rtfClient;

//{{RichCtrlAppVIRTUAL_BEGIN}}
public:
    virtual void InitMainWindow();
//{{RichCtrlAppVIRTUAL_END}}

//{{RichCtrlAppRSP_TBL_BEGIN}}
protected:
    void CmFilePrint ();
    void CmFilePrintSetup ();
    void CmPrintEnable (TCommandEnabler &tce);
    void CmHelpAbout ();
    void EvWinIniChange (char far* section);
    void CmExit ();
//{{RichCtrlAppRSP_TBL_END}}
DECLARE_RESPONSE_TABLE(RichCtrlApp);
};    //{{RichCtrlApp}}


#endif                                      // __rchctrla_h sentry.
