// DEMO 1  ***********************
// demonstracni program vypisuje na obrazovku zkusebni text
// Tato varianta je pro prekladac Borland C++, ale nevyuziva objekty.


#include <stdlib.h>
#include <graphics.h>
#include <stdio.h>
#include <conio.h>

// Data fontu: tabulka adres & sirek znaku "asci_tbf",
//                       pole bitovych map "asci_bmp",
// jsou z vystupniho souboru editoru fontu. Tento soubor ziskate volbou
// v menu "uloz zdroj. text" v editoru fontu (ma priponu .CPP). Nazvy poli
// jsou odvozeny z nazvu ukladaneho fontu. Do tohoto programu je prenesete
// pomoci clipboardu. Protoze obe polozky jsou pripojeny na konec programu,
// jsou zde deklarovany jako extern. Muzete vyuzit i projektu, pak data fontu
// zustanou v externim souboru, do projektu pridate tento soubor.
//
// Toto demo obsahuje jen vybrane funkce pro vypis na obrazovku.
// Predpoklada se pouziti pouze jednoho fontu v programu.

extern int asci_tbf[];
extern char asci_bmp[];

void GrInit()      // inicializace grafickeho rezimu VGA 640*480 bodu
{
int driver = VGA;
int mode = VGAHI;
int gr;
initgraph( &driver, &mode, "..\\bgi\\");

// uvedena cesta "..\\bgi\\" muze zpusobit chybu. Zalezi na nastaveni
// vystupniho adresare prekladace. Pri potizich udejte uplnou cestu
// k vasemu adresari bgi.

if ((gr=graphresult()) == 0) return;
  printf("Chyba grafickeho rezimu:\n>> %s <<\n",grapherrormsg(gr));
  getch();
  exit(EXIT_FAILURE);
}

// --------------------- FUNKCE PRO OBSLUHU RASTROVYCH FONTU ----------------
// struktura "font" zabali promenne fontu pro zvyseni ochrany.

struct font {
  int  far *t;       // ukazatel na tabulku adres bitovych map a sirek znaku
  char far *b;       // ukazatel na zacatek bitovych map znaku
  int xst, x, y;     // souradnice textu xst=zacatek pro viceradkovy text,
		     // x, y prubezne souradnice
  int color, status; // barva textu, status=kontrola inicializace
};
font FF;

//-----------------------------------
// funkce "showchar" vypise jeden znak na obrazovku. Znaky, ktere nejsou
// soucasti pripustne mnoziny znaku <32..t[1]>, budou ignorovany.

void showchar(unsigned char ch) {
  if ((ch<=FF.t[1]) && (ch>=32)) {
    int w, index, cx, cy;       // w=sirka znaku, index=adresa bitove mapy
    unsigned char pat;          // pat=vzorek bitove mapy (jeden byte)
    ch -=32;                    // cx, cy aktualni souradnice kresleneho bodu
    w = FF.t[2+2*ch+1];
    index = FF.t[2+2*ch];
    do {                                         // cyklus sirokych znaku
      for (cy=FF.y; (cy-FF.y)<FF.t[0]; cy++)  {  // cyklus vysky znaku
	pat = FF.b[index++];
	for (cx=FF.x; pat !=0; cx++, pat <<=1)   // cyklus jedne mikrolinky
	if (pat & 0x80) putpixel (cx, cy, FF.color);
      } FF.x+=8;
    } while((w-=8)>0);          // pro znaky sirsi nez 1 byte
    FF.x+=w;
  }
}
//-----------------------------------

// Funkce "showtext" vypise viceradkovy text na obrazovku. Barva textu
// je implicitne cerna, lze nastavit funkci setfontcolor

void showtext(int x, int y, char *str) {
  if (FF.status != -1) {
     outtextxy(x, y, "font neni inicializovan");
     return;
  }
  FF.xst=FF.x=x; FF.y=y;
  unsigned char ch;
  int i=0;
  while ((ch=str[i++]) != 0) {
    if (ch == '\n') { FF.x=FF.xst; FF.y+=FF.t[0]; }
    else showchar(ch);
  }
}
//------------------------------------

// Funkce "initfont" musi byt pouzita jako prvni, pred volanim ostatnich
// fontovych funkci. Provede inicializaci fontu.

void initfont(int *tt, unsigned char *bb) {
  FF.t=tt;
  FF.b=bb;
  FF.status=-1;
  FF.color=BLACK;
}
//-------------------------------------

// Funkce "setfontcolor" nastavi barvu textu
void setfontcolor (int barva) {
  FF.color=barva;
}
//---------------- KONEC FUNCI PRO FONTY -----------------------------------

void main(void) {

  GrInit();
  setfillstyle(SOLID_FILL, LIGHTGRAY);
  bar(0,0,639,479);

  initfont(asci_tbf, asci_bmp);
  showtext(100, 100, "Nazdar svete !");
  showtext(100, 200, "ABCDEFGHIJKLMNOPQRSTUVWXYZ");
  setfontcolor(BLUE);
  showtext(100, 216, "abcdefghijklmnopqrstuvwxyz");
  setfontcolor(RED);
  showtext(100, 316, "Toto je jednoduchy\nviceradkovy text\nbez hacku a carek");

  do {
   }  while(kbhit()==0);
  closegraph();
  return;
}

// Data fontu. Nasleduje obsah souboru, ktery vznikl z editoru fontu, volbou
// polozky z menu "uloz zdroj. text".  Uvedeny font umyslne neobsahuje
// rozsirenou cast tabulky s ceskymi znaky kvuliva minimalni delce souboru.

asci_tbf[]={   16,  127,
0x0000, 3,0x000d, 3,0x001a, 5,0x0027, 7,0x0034, 7,0x0042,10,0x0060, 9,
0x007d, 3,0x008a, 4,0x009a, 4,0x00aa, 7,0x00b5, 7,0x00c0, 3,0x00ce, 4,0x00d7, 3,
0x00e4, 4,0x00f3, 7,0x0100, 7,0x010d, 7,0x011a, 7,0x0127, 7,0x0134, 7,0x0141, 7,
0x014e, 7,0x015b, 7,0x0168, 7,0x0175, 3,0x0182, 3,0x0190, 7,0x019d, 7,0x01a9, 7,
0x01b6, 7,0x01c4,14,0x01e2, 9,0x01ff, 9,0x021c, 9,0x0239,10,0x0256, 9,0x0273, 8,
0x0280,10,0x029d,10,0x02ba, 3,0x02c7, 7,0x02d4, 8,0x02e1, 7,0x02ee,11,0x030b, 9,
0x0328,10,0x0345, 8,0x0352,10,0x036f, 9,0x038c, 9,0x03a9, 9,0x03c6,10,0x03e3, 9,
0x0400,13,0x041d, 8,0x042a, 9,0x0447, 9,0x0464, 4,0x0474, 4,0x0483, 4,0x0493, 7,
0x0498, 7,0x04a7, 4,0x04b1, 8,0x04be, 8,0x04cb, 7,0x04d8, 8,0x04e5, 8,0x04f2, 3,
0x04ff, 8,0x050f, 7,0x051c, 3,0x0529, 3,0x0539, 7,0x02ba, 3,0x0546,11,0x0563, 7,
0x0570, 8,0x057d, 8,0x058d, 8,0x059d, 4,0x05aa, 7,0x05b7, 3,0x05c4, 7,0x05d1, 7,
0x05de, 9,0x05f8, 7,0x0605, 7,0x0615, 6,0x0622, 5,0x0632, 3,0x0642, 5,0x0652, 9,
0x066f, 4};
unsigned char asci_bmp[]={
/*0x0000..*/   00,  00,  00,  00,  00,  00,  00,  00,  00,  00,  00,  00,  00,  00,  00,  00,
/*0x0010..*/ 0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,  00,0x40,  00,  00,  00,0x50,0x50,0x50,
/*0x0020..*/ 0x50,  00,  00,  00,  00,  00,  00,  00,  00,  00,0x14,0x14,0x14,0x7e,0x28,0x28,
/*0x0030..*/ 0xfc,0x50,0x50,0x50,  00,  00,  00,0x10,0x38,0x54,0x54,0x50,0x38,0x14,0x14,0x54,
/*0x0040..*/ 0x38,0x10,  00,  00,  00,0x31,0x49,0x4a,0x32,0x04,0x04,0x08,0x08,0x13,0x14,0x24,
/*0x0050..*/ 0x23,  00,  00,  00,  00,  00,  00,  00,  00,  00,  00,  00,  00,  00,0x80,0x80,
/*0x0060..*/   00,  00,  00,0x18,0x24,0x24,0x24,0x18,0x28,0x44,0x45,0x42,0x3d,  00,  00,  00,
/*0x0070..*/   00,  00,  00,  00,  00,  00,  00,  00,  00,  00,  00,  00,  00,  00,  00,  00,
/*0x0080..*/ 0x40,0x40,0x40,0x40,  00,  00,  00,  00,  00,  00,  00,  00,  00,0x10,0x20,0x20,
/*0x0090..*/ 0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x20,0x20,0x10,  00,  00,  00,0x80,0x40,0x40,
/*0x00a0..*/ 0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x40,0x40,0x80,  00,  00,  00,  00,  00,  00,
/*0x00b0..*/ 0x10,0x54,0x38,0x54,0x10,  00,  00,  00,  00,  00,  00,0x10,0x10,0x7c,0x10,0x10,
/*0x00c0..*/   00,  00,  00,  00,  00,  00,  00,  00,  00,  00,  00,  00,0x40,0x80,  00,  00,
/*0x00d0..*/   00,  00,  00,  00,  00,  00,0xf0,  00,  00,  00,  00,  00,  00,  00,  00,  00,
/*0x00e0..*/   00,  00,  00,0x40,  00,  00,  00,0x10,0x10,0x10,0x20,0x20,0x20,0x40,0x40,0x40,
/*0x00f0..*/ 0x80,0x80,0x80,  00,  00,  00,0x38,0x44,0x44,0x44,0x44,0x44,0x44,0x44,0x44,0x38,
/*0x0100..*/   00,  00,  00,0x10,0x70,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x10,  00,  00,  00,
/*0x0110..*/ 0x38,0x44,0x44,0x04,0x08,0x10,0x20,0x40,0x40,0x7c,  00,  00,  00,0x38,0x44,0x04,
/*0x0120..*/ 0x04,0x18,0x04,0x04,0x04,0x44,0x38,  00,  00,  00,0x04,0x0c,0x14,0x14,0x24,0x44,
/*0x0130..*/ 0x7c,0x04,0x04,0x04,  00,  00,  00,0x7c,0x40,0x40,0x40,0x78,0x44,0x04,0x04,0x44,
/*0x0140..*/ 0x38,  00,  00,  00,0x38,0x44,0x40,0x40,0x58,0x64,0x44,0x44,0x44,0x38,  00,  00,
/*0x0150..*/   00,0x7c,0x04,0x04,0x08,0x08,0x10,0x10,0x20,0x20,0x20,  00,  00,  00,0x38,0x44,
/*0x0160..*/ 0x44,0x44,0x38,0x44,0x44,0x44,0x44,0x38,  00,  00,  00,0x38,0x44,0x44,0x44,0x4c,
/*0x0170..*/ 0x34,0x04,0x04,0x44,0x38,  00,  00,  00,  00,  00,  00,0x40,  00,  00,  00,  00,
/*0x0180..*/   00,0x40,  00,  00,  00,  00,  00,  00,0x40,  00,  00,  00,  00,  00,0x40,0x80,
/*0x0190..*/   00,  00,  00,  00,0x04,0x08,0x10,0x20,0x40,0x20,0x10,0x08,0x04,  00,  00,  00,
/*0x01a0..*/   00,  00,  00,  00,0x7c,  00,0x7c,  00,  00,  00,  00,  00,  00,0x40,0x20,0x10,
/*0x01b0..*/ 0x08,0x04,0x08,0x10,0x20,0x40,  00,  00,  00,0x38,0x44,0x44,0x04,0x08,0x10,0x10,
/*0x01c0..*/ 0x10,  00,0x10,  00,  00,  00,0x07,0x18,0x20,0x20,0x43,0x44,0x44,0x44,0x23,0x20,
/*0x01d0..*/ 0x18,0x07,  00,  00,  00,  00,0x80,0x60,0x10,0x10,0xc8,0x48,0x48,0x88,0x70,  00,
/*0x01e0..*/ 0x30,0xc0,  00,  00,  00,0x08,0x08,0x14,0x14,0x22,0x22,0x7f,0x41,0x80,0x80,  00,
/*0x01f0..*/   00,  00,  00,  00,  00,  00,  00,  00,  00,  00,  00,  00,  00,0x80,0x80,  00,
/*0x0200..*/   00,  00,0x7e,0x41,0x41,0x41,0x7e,0x41,0x41,0x41,0x41,0x7e,  00,  00,  00,  00,
/*0x0210..*/   00,  00,  00,  00,  00,  00,  00,  00,  00,  00,  00,  00,  00,  00,  00,0x1e,
/*0x0220..*/ 0x21,0x40,0x40,0x40,0x40,0x40,0x40,0x21,0x1e,  00,  00,  00,  00,  00,  00,  00,
/*0x0230..*/   00,0x80,  00,  00,  00,  00,0x80,  00,  00,  00,  00,  00,0x7e,0x41,0x40,0x40,
/*0x0240..*/ 0x40,0x40,0x40,0x40,0x41,0x7e,  00,  00,  00,  00,  00,  00,  00,  00,0x80,0x80,
/*0x0250..*/ 0x80,0x80,0x80,0x80,  00,  00,  00,  00,  00,0x7f,0x40,0x40,0x40,0x7e,0x40,0x40,
/*0x0260..*/ 0x40,0x40,0x7f,  00,  00,  00,  00,  00,  00,  00,  00,  00,  00,  00,  00,  00,
/*0x0270..*/   00,  00,  00,  00,  00,  00,0x7f,0x40,0x40,0x40,0x7e,0x40,0x40,0x40,0x40,0x40,
/*0x0280..*/   00,  00,  00,0x1e,0x21,0x40,0x40,0x40,0x43,0x40,0x40,0x21,0x1e,  00,  00,  00,
/*0x0290..*/   00,  00,  00,  00,  00,0x80,  00,  00,0x80,0x80,0x80,0x80,0x80,  00,  00,  00,
/*0x02a0..*/ 0x40,0x40,0x40,0x40,0x7f,0x40,0x40,0x40,0x40,0x40,  00,  00,  00,  00,  00,  00,
/*0x02b0..*/ 0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,  00,  00,  00,0x40,0x40,0x40,
/*0x02c0..*/ 0x40,0x40,0x40,0x40,0x40,0x40,0x40,  00,  00,  00,0x04,0x04,0x04,0x04,0x04,0x04,
/*0x02d0..*/ 0x04,0x44,0x44,0x38,  00,  00,  00,0x42,0x44,0x48,0x50,0x60,0x50,0x48,0x44,0x42,
/*0x02e0..*/ 0x41,  00,  00,  00,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x7e,  00,  00,
/*0x02f0..*/   00,0x40,0x40,0x60,0x60,0x51,0x51,0x4a,0x4a,0x44,0x44,  00,  00,  00,  00,  00,
/*0x0300..*/   00,0x40,0x40,0xc0,0xc0,0x40,0x40,0x40,0x40,0x40,0x40,  00,  00,  00,0x61,0x61,
/*0x0310..*/ 0x51,0x51,0x49,0x49,0x45,0x45,0x43,0x43,  00,  00,  00,  00,  00,  00,  00,  00,
/*0x0320..*/   00,  00,  00,  00,  00,  00,  00,  00,  00,  00,  00,0x1e,0x21,0x40,0x40,0x40,
/*0x0330..*/ 0x40,0x40,0x40,0x21,0x1e,  00,  00,  00,  00,  00,  00,  00,  00,0x80,0x80,0x80,
/*0x0340..*/ 0x80,0x80,0x80,  00,  00,  00,  00,  00,0x7e,0x41,0x41,0x41,0x41,0x7e,0x40,0x40,
/*0x0350..*/ 0x40,0x40,  00,  00,  00,0x1e,0x21,0x40,0x40,0x40,0x40,0x40,0x42,0x21,0x1e,  00,
/*0x0360..*/   00,  00,  00,  00,  00,  00,  00,0x80,0x80,0x80,0x80,0x80,0x80,  00,0x80,  00,
/*0x0370..*/   00,  00,0x7e,0x41,0x41,0x41,0x41,0x7e,0x48,0x44,0x42,0x41,  00,  00,  00,  00,
/*0x0380..*/   00,  00,  00,  00,  00,  00,  00,  00,  00,  00,  00,  00,  00,  00,  00,0x3e,
/*0x0390..*/ 0x41,0x41,0x40,0x38,0x06,0x01,0x41,0x41,0x3e,  00,  00,  00,  00,  00,  00,  00,
/*0x03a0..*/   00,  00,  00,  00,  00,  00,  00,  00,  00,  00,  00,  00,0xff,0x08,0x08,0x08,
/*0x03b0..*/ 0x08,0x08,0x08,0x08,0x08,0x08,  00,  00,  00,  00,  00,  00,0x80,  00,  00,  00,
/*0x03c0..*/   00,  00,  00,  00,  00,  00,  00,  00,  00,0x40,0x40,0x40,0x40,0x40,0x40,0x40,
/*0x03d0..*/ 0x40,0x21,0x1e,  00,  00,  00,  00,  00,  00,0x80,0x80,0x80,0x80,0x80,0x80,0x80,
/*0x03e0..*/ 0x80,  00,  00,  00,  00,  00,0x80,0x80,0x41,0x41,0x22,0x22,0x14,0x14,0x08,0x08,
/*0x03f0..*/   00,  00,  00,  00,  00,  00,0x80,0x80,  00,  00,  00,  00,  00,  00,  00,  00,
/*0x0400..*/   00,  00,  00,0x82,0x82,0x82,0x45,0x45,0x28,0x28,0x28,0x10,0x10,  00,  00,  00,
/*0x0410..*/   00,  00,  00,0x08,0x08,0x08,0x10,0x10,0xa0,0xa0,0xa0,0x40,0x40,  00,  00,  00,
/*0x0420..*/ 0x81,0x81,0x42,0x24,0x18,0x18,0x24,0x42,0x81,0x81,  00,  00,  00,0x80,0x80,0x41,
/*0x0430..*/ 0x22,0x14,0x08,0x08,0x08,0x08,0x08,  00,  00,  00,  00,  00,  00,0x80,0x80,  00,
/*0x0440..*/   00,  00,  00,  00,  00,  00,  00,  00,  00,  00,0x7f,  00,0x01,0x02,0x04,0x08,
/*0x0450..*/ 0x10,0x20,0x40,0x7f,  00,  00,  00,  00,  00,  00,0x80,0x80,  00,  00,  00,  00,
/*0x0460..*/   00,  00,  00,0x80,  00,  00,  00,0x70,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,
/*0x0470..*/ 0x40,0x40,0x40,0x70,  00,  00,  00,0x80,0x80,0x80,0x40,0x40,0x40,0x20,0x20,0x20,
/*0x0480..*/ 0x10,0x10,0x10,  00,  00,  00,0xe0,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,
/*0x0490..*/ 0x20,0x20,0xe0,  00,  00,0x10,0x28,0x44,  00,  00,  00,  00,  00,  00,  00,  00,
/*0x04a0..*/   00,  00,  00,  00,  00,  00,0xfe,  00,  00,  00,0x40,0x20,  00,  00,  00,  00,
/*0x04b0..*/   00,  00,  00,  00,  00,  00,  00,0x3c,0x42,0x3e,0x42,0x42,0x42,0x3d,  00,  00,
/*0x04c0..*/   00,0x40,0x40,0x40,0x5c,0x62,0x42,0x42,0x42,0x62,0x5c,  00,  00,  00,  00,  00,
/*0x04d0..*/   00,0x3c,0x42,0x40,0x40,0x40,0x42,0x3c,  00,  00,  00,0x02,0x02,0x02,0x3a,0x46,
/*0x04e0..*/ 0x42,0x42,0x42,0x46,0x3a,  00,  00,  00,  00,  00,  00,0x3c,0x42,0x42,0x7e,0x40,
/*0x04f0..*/ 0x42,0x3c,  00,  00,  00,0x20,0x40,0x40,0xe0,0x40,0x40,0x40,0x40,0x40,0x40,  00,
/*0x0500..*/   00,  00,  00,  00,  00,0x3a,0x46,0x42,0x42,0x42,0x46,0x3a,0x02,0x02,0x3c,  00,
/*0x0510..*/   00,  00,0x40,0x40,0x40,0x58,0x64,0x44,0x44,0x44,0x44,0x44,  00,  00,  00,0x40,
/*0x0520..*/   00,  00,0x40,0x40,0x40,0x40,0x40,0x40,0x40,  00,  00,  00,0x40,  00,  00,0x40,
/*0x0530..*/ 0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x80,  00,  00,  00,0x40,0x40,0x40,0x44,
/*0x0540..*/ 0x48,0x50,0x70,0x48,0x44,0x42,  00,  00,  00,  00,  00,  00,0x59,0x66,0x44,0x44,
/*0x0550..*/ 0x44,0x44,0x44,  00,  00,  00,  00,  00,  00,  00,  00,  00,0x80,0x40,0x40,0x40,
/*0x0560..*/ 0x40,0x40,0x40,  00,  00,  00,  00,  00,  00,0x58,0x64,0x44,0x44,0x44,0x44,0x44,
/*0x0570..*/   00,  00,  00,  00,  00,  00,0x3c,0x42,0x42,0x42,0x42,0x42,0x3c,  00,  00,  00,
/*0x0580..*/   00,  00,  00,0x5c,0x62,0x42,0x42,0x42,0x62,0x5c,0x40,0x40,0x40,  00,  00,  00,
/*0x0590..*/   00,  00,  00,0x3a,0x46,0x42,0x42,0x42,0x46,0x3a,0x02,0x02,0x02,  00,  00,  00,
/*0x05a0..*/   00,  00,  00,0x50,0x60,0x40,0x40,0x40,0x40,0x40,  00,  00,  00,  00,  00,  00,
/*0x05b0..*/ 0x38,0x44,0x40,0x38,0x04,0x44,0x38,  00,  00,  00,  00,0x40,0x40,0xe0,0x40,0x40,
/*0x05c0..*/ 0x40,0x40,0x40,0x20,  00,  00,  00,  00,  00,  00,0x44,0x44,0x44,0x44,0x44,0x4c,
/*0x05d0..*/ 0x34,  00,  00,  00,  00,  00,  00,0x82,0x82,0x44,0x44,0x28,0x28,0x10,  00,  00,
/*0x05e0..*/   00,  00,  00,  00,0x88,0x88,0x55,0x55,0x55,0x22,0x22,  00,  00,  00,  00,  00,
/*0x05f0..*/   00,  00,  00,  00,0x80,0x80,  00,  00,  00,  00,  00,  00,  00,  00,0x82,0x44,
/*0x0600..*/ 0x28,0x10,0x28,0x44,0x82,  00,  00,  00,  00,  00,  00,0x82,0x82,0x44,0x44,0x28,
/*0x0610..*/ 0x28,0x10,0x10,0x20,0xc0,  00,  00,  00,  00,  00,  00,0x7c,0x04,0x08,0x10,0x20,
/*0x0620..*/ 0x40,0x7c,  00,  00,  00,0x18,0x20,0x20,0x20,0x20,0x20,0xc0,0x20,0x20,0x20,0x20,
/*0x0630..*/ 0x20,0x18,  00,  00,  00,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,
/*0x0640..*/ 0x40,0x40,  00,  00,  00,0xc0,0x20,0x20,0x20,0x20,0x20,0x18,0x20,0x20,0x20,0x20,
/*0x0650..*/ 0x20,0xc0,  00,  00,  00,0x31,0x49,0x46,  00,  00,  00,  00,  00,  00,  00,  00,
/*0x0660..*/   00,  00,  00,  00,  00,  00,  00,  00,  00,  00,  00,  00,  00,  00,  00,  00,
/*0x0670..*/   00,  00,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,  00,  00,  00};
;