// Hlavickovy soubor tridy RIFONT. Pridejte do Vaseho hlavickoveho
// souboru, vynechejte dublovane deklarace <include>.

#include <stdlib.h>
#include <graphics.h>
#include <stdio.h>
#include <dos.h>
#include <dir.h>
#include <conio.h>
#include <alloc.h>
#include <ctype.h>
#include <string.h>
#include <sys/stat.h>

// ************************************************************************
// *                              TRIDA  RIFONT                           *
// ************************************************************************

class RIFONT {
  void far *d;       // pointer na heap
  int  far *t;       // pointer na tabulku adres a sirek
  char far *b;       // pointer na zacatek bitmap
  unsigned char cch; // vypisovany znak
  int color, backgr; // barva pisma, barva pozadi
  int xstart;        // zacatek viceradkoveho textu
  int xx, yy, i;     // pomocne souradnice, citac znaku
  int status;        // status instance (vysledek inicializace)
  int  ready      (void);
  void showchar   (void);
  void overchar   (void);

  //----------------- nasledujici promenne a metody jen pro editaci textu:
  int xsed, xwed, ysed, yhed;     // graficke souradnice ramecku txed
  int xstarted, ystarted, yended; // graficke souradnice edit. textu
  int xcurr;                      // graficka souradnice x textoveho kurzoru
  int status_ed;     // 1=povolena editace, 0=zakazana
  int flaged;        // hlida funkci 1.znak maze puvodni text
  int pc;            // pozice znaku za kurzorem (v edit. bufferu)
  int pe;            // pozice posledniho znaku  (   -"-         )
  int nlen;          // povoleny pocet znaku editovaneho textu
  int tt;            // test pripustne mnoziny znaku
  char cursbuf[228]; // buffer pro edit. kurzor (max.vyska 24) NEZMENSOVAT !
  char * editbuf;    // ukazatel na edit. buffer
  void curs_hide  (void);
  void curs_show  (void);
  //---------------- konec potreb pro editaci --------------------------

public:
  RIFONT(void);                    // konstruktor, nasleduje volani load
  RIFONT(int *, unsigned char *);  // konstruktor, data soucasti programu
  ~RIFONT();                       // destruktor, musi uvolnit pamet HEAP
  int  load (char *);              // inicializace (nacteni dat ze souboru)
  void showchar      (int, int, unsigned char);      // vypis jednoho znaku
  void showtext      (int, int, char *);      // vypis viceradkoveho textu
  void overtext      (int, int, char *);      // text prepisuje pozadi
  void overchar      (int, int, unsigned char c);  // znak prepisuje pozadi
  void setfontcolor  (int c) {color=c;}       // nastavi trvale barvu textu
  void setfontbakgr  (int b) {backgr=b;}      // nastavi pozadi pro overtext
  int  getfontbackgr (void) {return backgr; } // vrati barvu pozadi z overtext
  int  getfontcolor  (void) {return color;  } // vrati nastavenou barvu textu
  int  gethigh  (void) { return t[0];}        // vrati vysku fontu
  int  getlast  (void) { return t[1];}        // vrati posledni platny znak
  int  getwidth (unsigned char);              // vrati sirku textu v pixelech
  int  getwidth (char *);                     // vrati sirku znaku v pixelech
  int  getstatus(void);                       // vrati status dat instance

  //---------nasledujici metody jen pro editaci textu:

  void txed_close(void);                      // zastavi editaci textu
  void txed_show (int, int, int, int, int, int, char *);// otevre edit. okno
  int  txed_mouse(int, int);                  // nastavi edit. kurzor mysi
  int  txed_keyb (int, int);                  // zpracuje znak z klavesnice
};

// ************************************************************************
// *   POMOCNE FUNKCE:   INICIALIZACE GRAF. REZIMU A OBSLUHA MYSI         *
// ************************************************************************

void GrInit(void);
void mouse_init(void);
void mouse_show(void);
void mouse_hide(void);
void mouse_pos (int *, int *, int *);